# Change Log
Cambios sobre kit de integración de CLAVE en tecnología .NET


## [3.0.0] - 18-DIC-2024
-- UH26987-235_UH26987-253_OT_15208_Actualizacion_de_Librerias_del_Kit_de_Integracion_NET
 Se actualizan las librerías 'log4net' y 'Newtonsoft.Json', se eliminan aquellas que no se usan, y se sube a la v4.8 del Framework .NET para este kit



---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
## [2.5.5] - 18-DIC-2024
-- UH26987-446_Mantenimiento_Actualizacion_Sello_Kit_de_Pruebas_para_Kits_de_Integracion
 - Se lleva a cabo la actualización del certificado que realiza la firma de las peticiones SAML que se envían a Pasarela (EIDAS CERTIFICADO PRUEBAS - 73F83A2E501A560F65EF0FAAAB588B9F) por caducidad del anterior.



---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
## [2.5.4] - 29-JUL-2024
-- UH26987-320_Mantenimiento_Kits_de_integración_certificado_SGAD_PRUEBAS
 - Se lleva a cabo la actualización del certificado SELLO ENTIDAD SGAD PRUEBAS (5f214302218d9201664355e30e5408a7) devuelto por Cl@ve-SE en sus respuestas SAML
-- UH26987-303-Soporte_Incidencia_106863
 - Resuelto problema de pérdida de sesión en Chrome sin modo incógnito.



---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
## [2.5.3] - 10-ENE-2023
-- CLV21-302_Actualización_del_Kit_de_Integración_.NET:_Retomar_el_Almacén_de_Confianza_de_Windows
 - Se deshace el cambio aplicado en la versión 2.5.2 en la que se llevaba a cabo la validación del certificado contra un almacén configurado para volver a hacer uso del almacén propio de Windows.
 - Se ha eliminado de la ruta 'Saml2SPWeb\App_Data' el almacén 'truststore.pfx' debido a que no se hará uso de él.
-- CLV21-319_Informe_de_Calidad_Cl@ve_2.8.3:_Incidencia_#1260159
 - Se añade la parte pública del certificado firmante de las respuesta SAML de Cl@ve SSEE (SELLO ENTIDAD SGAD PRUEBAS) en la carpeta 'Saml2SPWeb\App_Data\certificado_respuesta_clave-se.cer' para que los integradores puedan añadirlo al almacén correspondiente.



---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
## [2.5.2] - 22-NOV-2022
-- CLV21-253_Resultado_Informe_de_Pruebas_Kit_NET_v2.5.1
 - La validación de la confianza del certificado que devolvía la respuesta SAML de CLAVE se hacía contra el almacén de certificados propio de Windows. Se ha modificado esta parte del kit .NET para que la validación del certificado se haga contra un almacén configurado en el fichero 'properties.xml' en el parámetro 'dir_truststore' y la clave 'cert_password_trust'.
 - En la ruta 'Saml2SPWeb\App_Data' se ha añadido el almacén 'truststore.pfx' que contiene el certificado 'SELLO ENTIDAD SGAD PRUEBAS' de la respuesta SAML devuelta por SSEE.



---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
## [2.5.1] - 19-AGO-2022 // 21-SEP-2022
-- CLV21-134_Actualizar_Pack_integración_NET
 - Se añade el checkbox 'IDP Móvil' en la pantalla del SP DEMO del Kit .NET - Si se selecciona, se esconde el IDP Móvil de la pantalla de PASARELA, en caso de que el SP lo tuviera configurado -> "FUN-11.Implementación IDP Cl@ve Autenticador", para poder deseleccionar o seleccionar los nuevos IDP múltiples (Móvil).
 - También se ha actualizado el pack .NET con versiones más actuales, las librerías de soporte (SAML, .Net Framework, etc) y eliminado librerías potencialmente vulnerables o peligrosas.
 - Se ha aplicado una mejora pendiente en el tratamiento de certificados: CLV20-244: Mejora de certificados en integrador .Net 880906TO



---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
## [2.4] - 28-MAY-2021
Se actualiza a .Net 4.7.2
Se añade el proyecto de aplicación de consola Saml2UpdateCertCONSOLE para actualización automática de certificados de pasarela.

### Added
Ficheros añadidos:
* Saml2UpdateCertCONSOLE\Saml2UpdateCertCONSOLE.csproj
* Saml2UpdateCertCONSOLE\Program.cs
* Saml2UpdateCertCONSOLE\UpdateCertWorker.cs
* Saml2UpdateCertCONSOLE\ClaveCertificate.cs
* Saml2UpdateCertCONSOLE\App.config
* Saml2UpdateCertCONSOLE\packages.config
* Saml2UpdateCertCONSOLE\Properties\AssemblyInfo.cs

### Changed
Ficheros modificados:
* DemoSPSaml2.Net.sln
* App.Config 

### Fixed



---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
## [2.3.2] - 27-JUN-2022 // 21-SEP-2022
-- CLV21-142_Caducidad_certificado_firma_INT_PRE
 - Se configura de serie el Kit de .NET de CLAVE para que se conecte contra el SP de pruebas con providerName '21114293V_E04975701' (SP configurado en 'Saml2SPWeb\App_Data\properties.xml'), del entorno de Servicios Estables.



---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------- 
## [2.3.1] - 01-JUN-2022
-- CLV21-145_Actualizacion_certificados_firma_Kit_integracion_NET
 - En el SP del Kit de Integración .NET de CLAVE se han hecho algunas modificaciones a nivel de configuración, a raíz de un nuevo certificado que nos han enviado, ya que el anterior estaba caducado. Tarea relacionada 'CLV21-130_Actualizar_certificado_firma_SP2_hacia_Pasarela_en_INT_y_PRE'



---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
## [2.3] - 20-OCT-2020
Se recupera pagina ReturnPage.aspx que es necesaria para tratar correctamente la respuesta.
Se arregla la comprobación de los atributos “NotBefore” y “NotOnOrAfter” de la Response del IP en el tag Assertions\Conditions.
Se actualiza a Framework 4.7, para poder indicar SameSite a None
Se ha preparado para localhost con SSL, para forçar comunicación HTTPS y que funcione el Secure.
Se ha indicado que la cookie de session es SameSite None y Secure.

### Added

### Changed

Ficheros modificados:
* Saml2SPWeb/eu/sp/Handlers/ResponseHandler.cs
* Saml2SPWeb/Web.Config
* CommonSaml2/Conf.cs
* Saml2SPWeb/ReturnPage.aspx.*
* Saml2SPWeb/Saml2SPWeb.csproj
 
### Fixed



---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------- 
## [2.2] - 04-AGO-2020

Se comprueba los atributos “NotBefore” y “NotOnOrAfter” de la Response del IP en el tag Assertions\Conditions.

### Added

### Changed

Ficheros modificados:
* Saml2SPWeb/eu/sp/Handlers/ResponseHandler.cs
 
### Fixed



---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------  
## [2.1] - 11-MAY-2020

Se elimina de las request las Conditions “NotBefore” y “NotOnOrAfter”
Se añade parámetro ClockSkewHours a properties.xml: Este parámetro determina el margen extra de horas que se aplicará al comprobar los parámetros “NotBefore” y “NotOnOrAfter” de la Response del IP.
Se añade código para comprobar la validez del Token obtenido en la Response del IDP.
Se canvia ReturnPage por SuccessPage.
 
### Added

Nueva propiedad ClockSkewHours = "10" en fichero properties.xml.
 
### Changed

Ficheros modificados:
* Saml2SPWeb/App_Data/properties.xml
* CommonSaml2/Conf.cs
* CommonSaml2/Utils.cs
* CommonSaml2/XMLData.cs
* Saml2SPWeb/eu/sp/Handlers/ResponseHandler.cs
 
### Fixed
