﻿using System;
using System.Web;
using System.Text;
using System.Collections.Generic;
using System.Xml;

namespace Saml2Code
{
    public static class PostMethods
    {
        /// <summary>
        /// Creates first request to be send
        /// </summary>
        /// <param name="samlField">Name node</param>
        /// <param name="relayStateField">Name node</param>
        /// <param name="samlRequest">samlField value </param>
        /// <param name="relayState">relayStateField value</param>
        /// <param name="method">Method to send request</param>
        /// <returns>Request in String format</returns>
        public static string PreparePOSTForm(string samlField, string relayStateField,
            string samlRequest, string relayState, string method)
        {
            string spCountryURL = Conf.get_url_eidas();

            string formID = "PostForm", str = string.Empty;
            str += "<form id='" + formID + "' name='" + formID + "' action='" + spCountryURL + "' method='" + method + "'>";
            str += "<input type='hidden' name='" + samlField + "' value='" + samlRequest + "' />";
            str += "<input type='hidden' name='" + relayStateField + "' value='" + relayState + "' />";
            str += "</form>";
            str += "<script language='javascript'>";
            str += "var v" + formID + " = document." + formID + ";";
            str += "v" + formID + ".submit();";
            str += "</script>";
            return str;
        }
    }
}
